<template>
  <card>
    <!-- Card header -->
    <h3 slot="header" class="mb-0">New Project Site for ({{ model.project_code }})</h3>
    <div class="text-right">
    </div>
    <form class="needs-validation"
          @submit.prevent="submit">

      <!-- <div v-if="projects.length == 0" class="form-row">
        <b-col md="12">
        <h5 class="text-danger"> !!! Warning :
            <i>
            Please Create
            <router-link to="/ProjectNew">
                New Project
            </router-link>
            at Menu >> Project-Group-Site >> Project. System required at least ONE Project & One Group before you can proceed to create New Project Site.
            </i>
        </h5>
        </b-col>
      </div> -->

      <div v-if="project_groups.length == 0 && model.project_id != 'x'" class="form-row">
        <b-col md="12">
        <h5 class="text-danger"> !!! Warning :
            <i>
            Please Create
            <router-link :to="`/projectGroupNewFrProject/${model.project_id}`">
                New Group
            </router-link>
            at Menu >> Project-Group-Site >> Project Group. System required at least ONE Project & One Group before you can proceed to create New Project Site.
            </i>
        </h5>
        </b-col>
      </div>

      <div v-if="project_milestones.length == 0 && model.project_id != 'x'" class="form-row">
        <b-col md="12">
        <h5 class="text-danger"> !!! Warning :
            <i>
            Please Create
            <router-link :to="`/projectMilestoneListing/${model.project_id}`">
                New Project Milestone
            </router-link>
            at Menu >> Project-Group-Site >> Project >> Project Dashboard. System required at least ONE Milestone before you can proceed to create New Project Site.
            </i>
        </h5>
        </b-col>
      </div>

      <div class="form-row">
        <b-col md="6">
          <base-input label="Project Site Code"
                      name="Project Site Code"
                      placeholder="Project Site Code"
                      v-model="model.site_code">
          </base-input>
        </b-col>

        <b-col md="6">
          <base-input label="Project Leader"
                      name="Project Leader"
                      v-model="model.site_leader">
            <select class="form-control" v-model="model.site_leader">
              <option Selected disabled value="x">-- Please Select A Site Leader --</option>
              <option v-for="item in site_leads" :key="item.id" v-bind:value="item.id">{{ item.name }} - {{ item.email }}</option>
            </select>
          </base-input>
        </b-col>

        <b-col md="12">
          <base-input label="Project Site Name"
                      name="Project Site Name"
                      placeholder="Project Site Name"
                      v-model="model.site_name">
          </base-input>
        </b-col>

      </div>

      <div class="form-row">
        <b-col md="5">
          <base-input label="Project"
                      name="Project"
                      v-model="model.project_code" disabled>
            <!-- <select class="form-control" v-model="model.project_id" @change="getGroupFromProject()">
              <option Selected disabled value="x">-- Please Select A Project --</option>
              <option v-for="item in projects" :key="item.project_id" v-bind:value="item.project_id">{{ item.project_code }} - {{ item.project_name }}</option>
            </select> -->
          </base-input>
        </b-col>

        <b-col md="1">
          <br>
          <base-button size="sm" type="primary" @click="checkProject()">Project Infomation</base-button>
        </b-col>

        <b-col md="5">
          <base-input label="Group"
                      name="Group"
                      v-model="model.group_id">
            <select class="form-control" v-model="model.group_id">
              <option Selected disabled value="x">-- Please Select A Project To Show Group --</option>
              <option Selected disabled value="y">-- Please Select A Group --</option>
              <option v-for="item in project_groups" :key="item.group_id" v-bind:value="item.group_id">{{ item.group_code }} - {{ item.group_name }}</option>
            </select>
          </base-input>
        </b-col>

        <b-col md="1">
          <br>
          <base-button size="sm" type="primary" @click="checkGroup()">Group Infomation</base-button>
        </b-col>
      </div>

      <div class="form-row">
        <b-col md="6">
          <base-input label="Site Postal Code"
                      name="Site Postal Code"
                      placeholder="Site Postal Code"
                      v-model="model.site_postal_code">
          </base-input>
        </b-col>

        <b-col md="5">
          <base-input label="Site Current Milestone"
                      name="Site Current Milestone"
                      v-model="model.milestone_id">
            <select class="form-control" v-model="model.milestone_id">
              <option Selected disabled value="x">-- Please Select A Project To Show Milestone --</option>
              <option Selected disabled value="y">-- Please Select A Milestone --</option>
              <option v-for="item in project_milestones" :key="item.milestone_id" v-bind:value="item.milestone_id">{{ item.milestone_code }} - {{ item.milestone_info }}</option>
            </select>
          </base-input>
        </b-col>

        <b-col md="1">
          <br>
          <base-button size="sm" type="primary" @click="checkMilestone()">Milestone Details</base-button>
        </b-col>
      </div>

      <div class="form-row">
        <b-col md="5">
          <base-input label="Project Site Lead Contact"
                      name="Project Site Lead Contact"
                      placeholder="Project Site Lead Contact"
                      v-model="model.site_lead_contact">
          </base-input>
        </b-col>

        <b-col md="7">
          <base-input label="Project Site Address"
                      name="Project Site Address"
                      placeholder="Project Site Address"
                      v-model="model.site_address">
          </base-input>
        </b-col>
      </div>

      <div class="form-row">
        <b-col md="3">
          <base-input label="Project Site Status"
                      name="Project Site Status"
                      v-model="model.status_id">
            <select class="form-control" v-model="model.status_id">
              <option Selected disabled value="x">-- Please Select Site Status --</option>
              <option v-for="item in site_status" :key="item.status_id" v-bind:value="item.status_id">{{ item.status_code }}</option>
            </select>
          </base-input>
        </b-col>

        <b-col md="3">
          <base-input label="Project Site Progress % "
                      name="Project Site Progress"
                      placeholder="Project Site Progress"
                      v-model="model.site_progress" type="number" min="0" max="100">
          </base-input>
        </b-col>

        <b-col md="3">
          <base-input label="ELU License Number"
                      name="ELU License Number"
                      placeholder="ELU License Number"
                      v-model="model.site_elu_license_number">
          </base-input>
        </b-col>

        <b-col md="3">
          <base-input label="ELU Status"
                      name="ELU Status"
                      placeholder="ELU Status"
                      v-model="model.site_elu_status">
          </base-input>
        </b-col>
      </div>

      <div class="form-row">
        <b-col md="3">
          <base-input label="Project Site Module Quantity"
                      name="Project Site Module Quantity"
                      placeholder="Project Site Module Quantity"
                      v-model="model.site_module_quantity" @input="calculateSiteTotalCapacity()">
          </base-input>
        </b-col>

        <b-col md="3">
          <base-input label="Project Site Module Capacity (Wp)"
                      name="Project Site Module Capacity"
                      placeholder="Project Site Module Capacity"
                      v-model="model.site_module_capacity" @input="calculateSiteTotalCapacity()">
          </base-input>
        </b-col>

        <b-col md="3">
          <base-input label="Project Site Total Capacity (KWp)"
                      name="Project Site Total Capacity"
                      placeholder="Project Site Total Capacity"
                      v-model="model.site_total_capacity" readonly>
          </base-input>
        </b-col>

        <b-col md="3">
          <base-input label="Project Site PR Capacity"
                      name="Project Site PR Capacity"
                      placeholder="Project Site PR Capacity"
                      v-model="model.site_pr_capacity">
          </base-input>
        </b-col>
      </div>

      <div class="form-row">
        <b-col md="3">
          <base-input label="Project Site Type of Tension"
                      name="Project Site Type of Tension"
                      placeholder="Project Site Type of Tension"
                      v-model="model.site_type_of_tension">
          </base-input>
        </b-col>

        <b-col md="3">
          <base-input label="Project Site Approved Load"
                      name="Project Site Approved Load"
                      placeholder="Project Site Approved Load"
                      v-model="model.site_approved_load">
          </base-input>
        </b-col>

        <b-col md="3">
          <base-input label="Project Site MSSL Acc Number"
                      name="Project Site MSSL Acc Number"
                      placeholder="Project Site MSSL Acc Number"
                      v-model="model.site_mssl_account_number">
          </base-input>
        </b-col>

        <b-col md="3">
          <base-input label="Project Site Switchroom Tie"
                      name="Project Site Switchroom Tie"
                      placeholder="Project Site Switchroom Tie"
                      v-model="model.site_switchroom_tie">
          </base-input>
        </b-col>
      </div>

      <div class="form-row">
        <b-col md="4">
          <base-input label="Project Site Plant Name"
                      name="Project Site Plant Name"
                      placeholder="Project Site Plant Name"
                      v-model="model.site_plant_name">
          </base-input>
        </b-col>

        <b-col md="4">
          <base-input label="Project Site Folder in SFTP Server"
                      name="Project Site Folder in SFTP Server"
                      placeholder="Project Site Folder in SFTP Server"
                      v-model="model.site_folder_in_sftp_server">
          </base-input>
        </b-col>

        <b-col md="4">
          <base-input label="Project Site Monitoring Application"
                      name="Project Site Monitoring Application"
                      placeholder="Project Site Monitoring Application"
                      v-model="model.site_monitoring_application">
          </base-input>
        </b-col>
      </div>

      <div class="form-row">
        <b-col md="4">
          <base-input label="Project Site Total Inverter"
                      name="Project Site Total Inverter"
                      placeholder="Project Site Total Inverter"
                      v-model="model.site_total_inverter">
          </base-input>
        </b-col>

        <b-col md="4">
          <base-input label="Project Site Logger Type"
                      name="Project Site Logger Type"
                      placeholder="Project Site Logger Type"
                      v-model="model.site_logger_type">
          </base-input>
        </b-col>

        <b-col md="4">
          <base-input label="Project Site Total Data Logger"
                      name="Project Site Total Data Logger"
                      placeholder="Project Site Total Data Logger"
                      v-model="model.site_total_data_logger">
          </base-input>
        </b-col>
      </div>

      <div class="form-row">
        <b-col md="4">
          <base-input label="Project Site Start Date"
                      name="Project Site Start Date"
                      type="date"
                      v-model="model.site_start_date">
          </base-input>
        </b-col>
        <b-col md="4">
          <base-input label="Project Site End Date"
                      name="Project Site End Date"
                      type="date"
                      v-model="model.site_end_date">
          </base-input>
        </b-col>

        <b-col md="4">
          <base-input label="Contractual Start Date"
                      name="Contractual Start Date"
                      type="date"
                      v-model="model.site_contractor_start_date">
          </base-input>
        </b-col>
      </div>

      <div class="form-row">
        <b-col md="4">
          <base-input label="Contractual End Date"
                      name="Contractual End Date"
                      type="date"
                      v-model="model.site_contractor_end_date">
          </base-input>
        </b-col>
        <b-col md="4">
          <base-input label="ELU End Date"
                      name="ELU End Date"
                      type="date"
                      v-model="model.site_elu_end_date">
          </base-input>
        </b-col>

        <b-col md="4">
          <base-input label="EL Expiry Date"
                      name="EL Expiry Date"
                      type="date"
                      v-model="model.site_el_expiry_date">
          </base-input>
        </b-col>
      </div>

      <base-button type="primary" @click="createData()">Create New Project Site </base-button>
      <base-button type="primary" @click="$router.back()">Cancel</base-button>
      <div>
        <br>
        <h5 class="text-danger"> Note : <br><br>
                <i>
                1. By Default all Date is set to "TODAY, and Default date format will me DD/MM/YYYY.
                </i>
                <br>
                <i>
                2. Project Site Progress % is set to "0 %" By Default.
                </i>
                <br>
                <i>
                3. By Default system will not show any Project Group & Milestone. You need to Select A "Project" to SHOW Project Group & Milestone.
                </i>
        </h5>
      </div>
    </form>
  </card>
</template>
<script>
  import BaseSlider from '@/components/BaseSlider'
  import {LoginURL, clientId, clientSecret, apiDomain, getHeader, getcurrentDate} from '@/assets/js/config.js'
  import axios from 'axios'

  export default {
    components: {
      BaseSlider
    },
    created()
    {
      var currentDate = getcurrentDate()

      this.model.site_start_date = currentDate
      this.model.site_end_date = currentDate
      this.model.site_contractor_start_date = currentDate
      this.model.site_contractor_end_date = currentDate
      this.model.site_elu_end_date = currentDate
      this.model.site_el_expiry_date = currentDate

      this.model.project_id = this.$route.params.id

      axios.get(apiDomain + 'project/project/' + this.model.project_id, { headers: getHeader() })
      .then ( response => {
        if (response.status === 200)
        {
          this.model.project_code = response.data.data[0].project_code
          this.getGroupFromProject()
        }
      })
      .catch ( error => {
        console.log(error.response.status)
      } );

      axios.get(apiDomain + 'lookup/site_status', { headers: getHeader() })
      .then ( response => {
        if (response.status === 200)
        {
          this.site_status = response.data.data
        }
      })
      .catch ( error => {
        console.log(error.response.status)
      } );

      axios.get(apiDomain + 'lookup/user_list/Project_Lead', { headers: getHeader() })
      .then ( response => {
        if (response.status === 200)
        {
          this.site_leads = response.data.data
        }
      })
      .catch ( error => {
        console.log(error.response.status)
      } );

      this.calculateSiteTotalCapacity()

    },
    data() {
      return {
        model: {
          project_id: 'x',
          project_code: null,
          group_id: 'x',
          site_code: null,
          site_name: null,
          site_leader: 'x',
          site_postal_code: '569933',
          site_address: 'Site Address',
          site_lead_contact: '+65123456789',
          site_progress: 1,
          milestone_id: 'x',
          site_module_quantity: 1,
          site_module_capacity: 1,
          site_total_capacity: 1,
          site_pr_capacity: 1,
          site_type_of_tension: 'None',
          site_approved_load: 1,
          site_mssl_account_number: 'MSSL Account Number',
          site_switchroom_tie: 'Switchroom Tie',
          site_plant_name: 'Plant Name',
          site_folder_in_sftp_server: 'SFTP',
          site_monitoring_application: 'SolarMon',
          site_total_inverter: 1,
          site_total_data_logger: 1,
          site_logger_type: 'HwaWei',
          site_start_date: null,
          site_end_date: null,
          site_contractor_start_date: null,
          site_contractor_end_date: null,
          site_elu_end_date: null,
          site_el_expiry_date: null,
          site_elu_license_number: 'ELU License',
          site_elu_status: 'ELU Status',
          status_id: 1,
        },
        projects: [],
        project_groups: [],
        site_status: [],
        site_leads: [],
        project_milestones: [],
      }
    },
    methods: {
      calculateSiteTotalCapacity()
      {
          //this.model.site_total_capacity = (this.model.site_module_quantity * this.model.site_module_capacity
          this.model.site_total_capacity = ((this.model.site_module_quantity * this.model.site_module_capacity) / 1000)
      },
      getGroupFromProject()
      {
        axios.get(apiDomain + 'project/project_group.show_by_project/' + this.model.project_id , { headers: getHeader() })
        .then ( response => {
          if (response.status === 200)
          {
            this.project_groups = response.data.data
            this.model.group_id = 'y'
          }
        })
        .catch ( error => {
          console.log(error.response.status)
        } );

        axios.get(apiDomain + 'project/project_milestone.show_by_project/' + this.model.project_id , { headers: getHeader() })
        .then ( response => {
          if (response.status === 200)
          {
            this.project_milestones = response.data.data
            this.model.milestone_id = 'y'
          }
        })
        .catch ( error => {
          console.log(error.response.status)
        } );
      },
      checkProject()
      {
        if (this.model.project_id == 'x')
        {
          this.$notify({
            message:
              '<b>Invalid Input : Project </b> - Please select a Project before dive into the Details',
            timeout: 10000,
            icon: 'ni ni-bulb-61',
            type: 'danger',
          });
        }
        else
        {
          this.$router.push({path: '/projectEdit/'+this.model.project_id })
        }
      },
      checkGroup()
      {
        if (this.model.group_id == 'x' || this.model.group_id == 'y')
        {
          this.$notify({
            message:
              '<b>Invalid Input : Project Group </b> - Please select a Project Group before dive into the Details',
            timeout: 10000,
            icon: 'ni ni-bulb-61',
            type: 'danger',
          });
        }
        else
        {
          this.$router.push({path: '/projectGroupEdit/'+this.model.group_id })
        }
      },
      checkMilestone()
      {
        if (this.model.milestone_id == 'x' || this.model.milestone_id == 'y')
        {
          this.$notify({
            message:
              '<b>Invalid Input : Project Milestone </b> - Please select a Project Milestone before dive into the Details',
            timeout: 10000,
            icon: 'ni ni-bulb-61',
            type: 'danger',
          });
        }
        else
        {
          this.$router.push({path: '/projectMilestoneEdit/'+this.model.milestone_id })
        }
      },
      createData(){
        if (
        !this.model.site_code || !this.model.site_name || this.model.project_id == 'x' || this.model.status_id == 'x' || this.model.group_id == 'x' || this.model.group_id == 'y' ||
        this.model.site_leader == 'x' || this.model.milestone_id == 'x' || this.model.milestone_id == 'y' ||
        !this.model.site_postal_code || !this.model.site_address || !this.model.site_module_quantity ||
        !this.model.site_module_quantity || !this.model.site_module_capacity || !this.model.site_total_capacity || !this.model.site_pr_capacity ||
        !this.model.site_type_of_tension || !this.model.site_approved_load || !this.model.site_mssl_account_number || !this.model.site_switchroom_tie ||
        !this.model.site_plant_name || !this.model.site_folder_in_sftp_server || !this.model.site_monitoring_application || !this.model.site_total_inverter ||
        !this.model.site_total_data_logger || !this.model.site_logger_type || !this.model.site_elu_license_number || !this.model.site_elu_status
        )
        {
          this.$notify({
            message:
              '<b>Invalid Input : All Column are Mandatory in Create New Project Site </b> - These field are required.',
            timeout: 10000,
            icon: 'ni ni-bulb-61',
            type: 'danger',
          });
        }
        else if( this.model.site_progress < 0 || this.model.site_progress > 100 )
        {
          this.$notify({
            message:
              '<b>Invalid Input : Project Site Progress </b> - Input Must be between 0 - 100',
            timeout: 10000,
            icon: 'ni ni-bulb-61',
            type: 'danger',
          });
        }
        else
        {
          // console.log(this.model)
          axios.post(apiDomain + 'project/project_site', this.model, { headers: getHeader() })
          .then ( response => {
            if (response.status === 200)
            {
                this.$notify({
                message:
                  '<b>New Project Site : ' + this.model.site_code + '</b> - Successfully Created.',
                timeout: 10000,
                icon: 'ni ni-bell-55',
                type: 'default',
                });
                this.$router.back()
            }
          })
          .catch ( error => {
              console.log(error.response.data.errors)
              this.$notify({
                message:
                  '<b>Invalid Input : ' + this.model.site_code + ' </b> - The Code already exists in the system, Please choose a different Code.',
                timeout: 10000,
                icon: 'ni ni-bulb-61',
                type: 'danger',
              });
          });
        }
      },
    }
  }
</script>
<style>
</style>
